--- net/minecraft/src/Packet23VehicleSpawn.java
+++ net/minecraft/src/Packet23VehicleSpawn.java
@@ -9,7 +9,11 @@
 	public int xPosition;
 	public int yPosition;
 	public int zPosition;
+	public int field_28047_e;
+	public int field_28046_f;
+	public int field_28045_g;
 	public int type;
+	public int field_28044_i;
 
 	public void readPacketData(DataInputStream var1) throws IOException {
 		this.entityId = var1.readInt();
@@ -17,14 +21,28 @@
 		this.xPosition = var1.readInt();
 		this.yPosition = var1.readInt();
 		this.zPosition = var1.readInt();
+		this.field_28044_i = var1.readInt();
+		if(this.field_28044_i > 0) {
+			this.field_28047_e = var1.readShort();
+			this.field_28046_f = var1.readShort();
+			this.field_28045_g = var1.readShort();
+		}
+
 	}
 
-	public void writePacket(DataOutputStream var1) throws IOException {
+	public void writePacketData(DataOutputStream var1) throws IOException {
 		var1.writeInt(this.entityId);
 		var1.writeByte(this.type);
 		var1.writeInt(this.xPosition);
 		var1.writeInt(this.yPosition);
 		var1.writeInt(this.zPosition);
+		var1.writeInt(this.field_28044_i);
+		if(this.field_28044_i > 0) {
+			var1.writeShort(this.field_28047_e);
+			var1.writeShort(this.field_28046_f);
+			var1.writeShort(this.field_28045_g);
+		}
+
 	}
 
 	public void processPacket(NetHandler var1) {
@@ -32,6 +50,6 @@
 	}
 
 	public int getPacketSize() {
-		return 17;
+		return 21 + this.field_28044_i > 0 ? 6 : 0;
 	}
 }
--- net/minecraft/src/ChunkCoordinates.java
+++ net/minecraft/src/ChunkCoordinates.java
@@ -1,12 +1,23 @@
 package net.minecraft.src;
 
-final class ChunkCoordinates {
-	public final int posX;
-	public final int posZ;
-
-	public ChunkCoordinates(int var1, int var2) {
-		this.posX = var1;
-		this.posZ = var2;
+public class ChunkCoordinates implements Comparable {
+	public int x;
+	public int y;
+	public int z;
+
+	public ChunkCoordinates() {
+	}
+
+	public ChunkCoordinates(int var1, int var2, int var3) {
+		this.x = var1;
+		this.y = var2;
+		this.z = var3;
+	}
+
+	public ChunkCoordinates(ChunkCoordinates var1) {
+		this.x = var1.x;
+		this.y = var1.y;
+		this.z = var1.z;
 	}
 
 	public boolean equals(Object var1) {
@@ -14,11 +25,26 @@
 			return false;
 		} else {
 			ChunkCoordinates var2 = (ChunkCoordinates)var1;
-			return this.posX == var2.posX && this.posZ == var2.posZ;
+			return this.x == var2.x && this.y == var2.y && this.z == var2.z;
 		}
 	}
 
 	public int hashCode() {
-		return this.posX << 16 ^ this.posZ;
+		return this.x + this.z << 8 + this.y << 16;
+	}
+
+	public int compareChunkCoordinate(ChunkCoordinates var1) {
+		return this.y == var1.y ? (this.z == var1.z ? this.x - var1.x : this.z - var1.z) : this.y - var1.y;
+	}
+
+	public double getSqDistanceTo(int var1, int var2, int var3) {
+		int var4 = this.x - var1;
+		int var5 = this.y - var2;
+		int var6 = this.z - var3;
+		return Math.sqrt((double)(var4 * var4 + var5 * var5 + var6 * var6));
+	}
+
+	public int compareTo(Object var1) {
+		return this.compareChunkCoordinate((ChunkCoordinates)var1);
 	}
 }
